VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frm_halftone 
   Caption         =   "Halftone"
   ClientHeight    =   1710
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   3960
   OleObjectBlob   =   "frm_halftone.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frm_halftone"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub btn_halftone_Click()
    make_halftone scr_halftone_size.Value, scr_halftone_bright * 10, scr_halftone_red / 10, frm_halftone_square
End Sub

Private Sub scr_halftone_bright_Change()
    lbl_halftone_bright = scr_halftone_bright.Value
End Sub

Private Sub scr_halftone_size_Change()
    lbl_halftone_size = scr_halftone_size.Value
End Sub

Private Sub scr_halftone_red_Change()
    lbl_halftone_red = scr_halftone_red.Value
End Sub

Private Sub UserForm_Activate()
    scr_halftone_bright_Change
    scr_halftone_size_Change
    scr_halftone_red_Change
End Sub

Sub make_halftone(Optional siz = 5, Optional bright = 220, Optional red_factor = 0.5, Optional sq = False)
    Dim os As ShapeRange, sr_ci As New ShapeRange
    Dim s As Shape, fir As Shape
    Dim clr As Color

    Set os = ActiveSelectionRange
    If os.Shapes.Count > 0 Then
        'siz = 2
        'bright = 220
        sgap = siz / 2
        ud = ActiveDocument.Unit
        ActiveDocument.Unit = cdrTenthMicron
On Error GoTo errn
        ActiveDocument.BeginCommandGroup "all reset names"
        Application.Optimization = True
        For Each s In os.Shapes
            sr_ci.RemoveAll
            If s.Type = cdrBitmapShape Then
                'If s.Bitmap.mode <> cdrGrayscaleImage Then s.Bitmap.ConvertTo 2
                pxstep = s.SizeWidth / s.Bitmap.Image.Width
                cisize = ((pxstep * siz) / 2) / bright
                lx = vall(s.Bitmap.Image.Width / siz, 0)
                ly = vall(s.Bitmap.Image.Height / siz, 0)
                For yy = 1 To ly - 1
                    For xx = 1 To lx - 1
                        mr = 0
                        mg = 0
                        mb = 0
                        mc = 0
                        For smy = yy * siz - siz To yy * siz - 1
                            For smx = xx * siz - siz To xx * siz - 1
                                xhex = s.Bitmap.Image.Pixel(smx, smy).HexValue
                                mr = mr + Int("&H" & Mid(xhex, 2, 2)) * red_factor
                                mg = mg + Int("&H" & Mid(xhex, 4, 2))
                                mb = mb + Int("&H" & Mid(xhex, 6, 2))
                                mc = mc + 1
                            Next smx
                        Next smy
                        If mc > 0 Then
                            smx = s.SizeWidth * 1.2 + s.LeftX + (xx * siz - siz / 2) * pxstep
                            smy = s.BottomY + (yy * siz - siz / 2) * pxstep
                            csize = cisize * (255 - (mr + mg + mb) / (mc * 3))
                            If csize < 250 Then csize = 250
                            If sq Then
                                Set ci = ActiveVirtualLayer.CreateRectangle2(smx - csize / 2, smy - csize / 2, csize, csize, 0, 0, 0, 0)
                                ci.Rotate 45
                            Else
                                Set ci = ActiveVirtualLayer.CreateEllipse2(smx, smy, csize)
                            End If
                            sr_ci.Add ci
                        End If
                    Next xx
                Next yy
                If sr_ci.Shapes.Count > 0 Then
                    sr_ci.MoveToLayer ActiveLayer
                    ci.Fill.UniformColor.RGBAssign 0, 0, 0
                    ci.Outline.SetNoOutline
                    sr_ci.group
                    sr_ci.ApplyFill ci.Fill
                    sr_ci.ApplyOutline ci.Outline
                End If
            End If
            's.Move -s.SizeWidth * 1.2, 0
        Next s
errn:
        Application.Optimization = False
        ActiveDocument.EndCommandGroup
        Application.Refresh
        ActiveDocument.Unit = ud
    End If
End Sub
